IRremoteESP8266: IRHitachiAc1 Class Reference

IRremoteESP8266

Public Member Functions | Static Public Member Functions | Private Member Functions | Private Attributes | List of all members
IRHitachiAc1 Class Reference

Class for handling detailed Hitachi 104-bit A/C messages. More...

`#include <ir_Hitachi.h>`

Collaboration diagram for IRHitachiAc1:
[legend]

## Public Member Functions

| IRHitachiAc1 (const uint16_t pin, const bool inverted=false, const bool use_modulation=true)
| Class constructor. More...
void | stateReset (void)
| Reset the internal state to a fixed known good state. More...
void | send (const uint16_t repeat=kHitachiAcDefaultRepeat)
| Send the current internal state as an IR message. More...
int8_t | calibrate (void)
| Run the calibration to calculate uSec timing offsets for this platform. More...
void | begin (void)
| Set up hardware to be able to send a message. More...
void | on (void)
| Change the power setting to On. More...
void | off (void)
| Change the power setting to Off. More...
void | setModel (const hitachi_ac1_remote_model_t model)
| Set the model of the A/C to emulate. More...
hitachi_ac1_remote_model_t | getModel (void) const
| Get/Detect the model of the A/C. More...
void | setPower (const bool on)
| Change the power setting. More...
bool | getPower (void) const
| Get the value of the current power setting. More...
void | setPowerToggle (const bool on)
| Change the power toggle setting. More...
bool | getPowerToggle (void) const
| Get the value of the current power toggle setting. More...
void | setTemp (const uint8_t temp)
| Set the temperature. More...
uint8_t | getTemp (void) const
| Get the current temperature setting. More...
void | setFan (const uint8_t speed, const bool force=false)
| Set the speed of the fan. More...
uint8_t | getFan (void) const
| Get the current fan speed setting. More...
void | setMode (const uint8_t mode)
| Set the operating mode of the A/C. More...
uint8_t | getMode (void) const
| Get the operating mode setting of the A/C. More...
void | setSwingToggle (const bool toggle)
| Set the Swing toggle setting of the A/C. More...
bool | getSwingToggle (void) const
| Get the Swing Toggle setting of the A/C. More...
void | setSwingV (const bool on)
| Set the Vertical Swing setting of the A/C. More...
bool | getSwingV (void) const
| Get the Vertical Swing setting of the A/C. More...
void | setSwingH (const bool on)
| Set the Horizontal Swing setting of the A/C. More...
bool | getSwingH (void) const
| Get the Horizontal Swing setting of the A/C. More...
void | setSleep (const uint8_t mode)
| Set the Sleep setting of the A/C. More...
uint8_t | getSleep (void) const
| Get the Sleep setting of the A/C. More...
void | setOnTimer (const uint16_t mins)
| Set the On Timer time. More...
uint16_t | getOnTimer (void) const
| Get the On Timer vtime of the A/C. More...
void | setOffTimer (const uint16_t mins)
| Set the Off Timer time. More...
uint16_t | getOffTimer (void) const
| Get the Off Timer vtime of the A/C. More...
uint8_t * | getRaw (void)
| Get a PTR to the internal state/code for this protocol. More...
void | setRaw (const uint8_t new_code[], const uint16_t length=kHitachiAc1StateLength)
| Set the internal state from a valid code for this protocol. More...
stdAc::state_t | toCommon (void) const
| Convert the current internal state into its stdAc::state_t equivalent. More...
String | toString (void) const
| Convert the current internal state into a human readable string. More...

## Static Public Member Functions

static bool | validChecksum (const uint8_t state[], const uint16_t length=kHitachiAc1StateLength)
| Verify the checksum is valid for a given state. More...
static uint8_t | calcChecksum (const uint8_t state[], const uint16_t length=kHitachiAc1StateLength)
| Calculate the checksum for a given state. More...
static uint8_t | convertMode (const stdAc::opmode_t mode)
| Convert a stdAc::opmode_t enum into its native mode. More...
static uint8_t | convertFan (const stdAc::fanspeed_t speed)
| Convert a stdAc::fanspeed_t enum into it's native speed. More...
static stdAc::opmode_t | toCommonMode (const uint8_t mode)
| Convert a native mode into its stdAc equivalent. More...
static stdAc::fanspeed_t | toCommonFanSpeed (const uint8_t speed)
| Convert a native fan speed into its stdAc equivalent. More...

## Private Member Functions

void | checksum (const uint16_t length=kHitachiAc1StateLength)
| Calculate and set the checksum values for the internal state. More...

## Private Attributes

IRsend | _irsend
| Instance of the IR send class. More...
Hitachi1Protocol | _

## Detailed Description

Class for handling detailed Hitachi 104-bit A/C messages.

See also
  https://github.com/crankyoldgit/IRremoteESP8266/issues/1056

## Constructor & Destructor Documentation

## ◆ IRHitachiAc1()

IRHitachiAc1::IRHitachiAc1 | ( | const uint16_t | pin,
|  | const bool | inverted = `false`,
|  | const bool | use_modulation = `true`
| ) |  |

explicit

Class constructor.

Parameters

  [in] | pin | GPIO to be used when sending.
  [in] | inverted | Is the output signal to be inverted?
  [in] | use_modulation | Is frequency modulation to be used?

## Member Function Documentation

## ◆ begin()

void IRHitachiAc1::begin | ( | void |  | ) |

Set up hardware to be able to send a message.

## ◆ calcChecksum()

uint8_t IRHitachiAc1::calcChecksum | ( | const uint8_t | state[],
|  | const uint16_t | length = `kHitachiAc1StateLength`
| ) |  |

static

Calculate the checksum for a given state.

Parameters

  [in] | state | The value to calc the checksum of.
  [in] | length | The size/length of the state.

Returns
  The calculated checksum value.

## ◆ calibrate()

int8_t IRHitachiAc1::calibrate | ( | void |  | ) |

inline

Run the calibration to calculate uSec timing offsets for this platform.

Returns
  The uSec timing offset needed per modulation of the IR Led.

Note
  This will produce a 65ms IR signal pulse at 38kHz. Only ever needs to be run once per object instantiation, if at all.

## ◆ checksum()

void IRHitachiAc1::checksum | ( | const uint16_t | length = `kHitachiAc1StateLength` | ) |

private

Calculate and set the checksum values for the internal state.

Parameters

  [in] | length | The size/length of the state.

## ◆ convertFan()

uint8_t IRHitachiAc1::convertFan | ( | const stdAc::fanspeed_t | speed | ) |

static

Convert a stdAc::fanspeed_t enum into it's native speed.

Parameters

  [in] | speed | The enum to be converted.

Returns
  The native equivalent of the enum.

## ◆ convertMode()

uint8_t IRHitachiAc1::convertMode | ( | const stdAc::opmode_t | mode | ) |

static

Convert a stdAc::opmode_t enum into its native mode.

Parameters

  [in] | mode | The enum to be converted.

Returns
  The native equivalent of the enum.

## ◆ getFan()

uint8_t IRHitachiAc1::getFan | ( | void |  | ) | const

Get the current fan speed setting.

Returns
  The current fan speed.

## ◆ getMode()

uint8_t IRHitachiAc1::getMode | ( | void |  | ) | const

Get the operating mode setting of the A/C.

Returns
  The current operating mode setting.

## ◆ getModel()

hitachi_ac1_remote_model_t IRHitachiAc1::getModel | ( | void |  | ) | const

Get/Detect the model of the A/C.

Returns
  The enum of the compatible model.

## ◆ getOffTimer()

uint16_t IRHitachiAc1::getOffTimer | ( | void |  | ) | const

Get the Off Timer vtime of the A/C.

Returns
  Nr of minutes the timer is set to.

## ◆ getOnTimer()

uint16_t IRHitachiAc1::getOnTimer | ( | void |  | ) | const

Get the On Timer vtime of the A/C.

Returns
  Nr of minutes the timer is set to.

## ◆ getPower()

bool IRHitachiAc1::getPower | ( | void |  | ) | const

Get the value of the current power setting.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getPowerToggle()

bool IRHitachiAc1::getPowerToggle | ( | void |  | ) | const

Get the value of the current power toggle setting.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getRaw()

uint8_t * IRHitachiAc1::getRaw | ( | void |  | ) |

Get a PTR to the internal state/code for this protocol.

Returns
  PTR to a code for this protocol based on the current internal state.

## ◆ getSleep()

uint8_t IRHitachiAc1::getSleep | ( | void |  | ) | const

Get the Sleep setting of the A/C.

Returns
  The currently configured sleep mode.

Note
  Sleep modes only available in Auto & Cool modes, otherwise it's off.

## ◆ getSwingH()

bool IRHitachiAc1::getSwingH | ( | void |  | ) | const

Get the Horizontal Swing setting of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getSwingToggle()

bool IRHitachiAc1::getSwingToggle | ( | void |  | ) | const

Get the Swing Toggle setting of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getSwingV()

bool IRHitachiAc1::getSwingV | ( | void |  | ) | const

Get the Vertical Swing setting of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getTemp()

uint8_t IRHitachiAc1::getTemp | ( | void |  | ) | const

Get the current temperature setting.

Returns
  The current setting for temp. in degrees celsius.

## ◆ off()

void IRHitachiAc1::off | ( | void |  | ) |

Change the power setting to Off.

## ◆ on()

void IRHitachiAc1::on | ( | void |  | ) |

Change the power setting to On.

## ◆ send()

void IRHitachiAc1::send | ( | const uint16_t | repeat = `kHitachiAcDefaultRepeat` | ) |

Send the current internal state as an IR message.

Parameters

  [in] | repeat | Nr. of times the message will be repeated.

## ◆ setFan()

void IRHitachiAc1::setFan | ( | const uint8_t | speed,
|  | const bool | force = `false`
| ) |  |

Set the speed of the fan.

Parameters

  [in] | speed | The desired setting.
  [in] | force | Deprecated

## ◆ setMode()

void IRHitachiAc1::setMode | ( | const uint8_t | mode | ) |

Set the operating mode of the A/C.

Parameters

  [in] | mode | The desired operating mode.

## ◆ setModel()

void IRHitachiAc1::setModel | ( | const hitachi_ac1_remote_model_t | model | ) |

Set the model of the A/C to emulate.

Parameters

  [in] | model | The enum of the appropriate model.

## ◆ setOffTimer()

void IRHitachiAc1::setOffTimer | ( | const uint16_t | mins | ) |

Set the Off Timer time.

Parameters

  [in] | mins | The time expressed in total number of minutes.

## ◆ setOnTimer()

void IRHitachiAc1::setOnTimer | ( | const uint16_t | mins | ) |

Set the On Timer time.

Parameters

  [in] | mins | The time expressed in total number of minutes.

## ◆ setPower()

void IRHitachiAc1::setPower | ( | const bool | on | ) |

Change the power setting.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setPowerToggle()

void IRHitachiAc1::setPowerToggle | ( | const bool | on | ) |

Change the power toggle setting.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setRaw()

void IRHitachiAc1::setRaw | ( | const uint8_t | new_code[],
|  | const uint16_t | length = `kHitachiAc1StateLength`
| ) |  |

Set the internal state from a valid code for this protocol.

Parameters

  [in] | new_code | A valid code for this protocol.
  [in] | length | The length of the new_code array.

## ◆ setSleep()

void IRHitachiAc1::setSleep | ( | const uint8_t | mode | ) |

Set the Sleep setting of the A/C.

Parameters

  [in] | mode | The mode of sleep to set the A/C to.

Note
  Sleep modes only available in Auto & Cool modes, otherwise it's off.

## ◆ setSwingH()

void IRHitachiAc1::setSwingH | ( | const bool | on | ) |

Set the Horizontal Swing setting of the A/C.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setSwingToggle()

void IRHitachiAc1::setSwingToggle | ( | const bool | toggle | ) |

Set the Swing toggle setting of the A/C.

Parameters

  [in] | toggle | true, the setting is on. false, the setting is off.

## ◆ setSwingV()

void IRHitachiAc1::setSwingV | ( | const bool | on | ) |

Set the Vertical Swing setting of the A/C.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setTemp()

void IRHitachiAc1::setTemp | ( | const uint8_t | celsius | ) |

Set the temperature.

Parameters

  [in] | celsius | The temperature in degrees celsius.

## ◆ stateReset()

void IRHitachiAc1::stateReset | ( | void |  | ) |

Reset the internal state to a fixed known good state.

## ◆ toCommon()

stdAc::state_t IRHitachiAc1::toCommon | ( | void |  | ) | const

Convert the current internal state into its stdAc::state_t equivalent.

Returns
  The stdAc equivalent of the native settings.

## ◆ toCommonFanSpeed()

stdAc::fanspeed_t IRHitachiAc1::toCommonFanSpeed | ( | const uint8_t | speed | ) |

static

Convert a native fan speed into its stdAc equivalent.

Parameters

  [in] | speed | The native setting to be converted.

Returns
  The stdAc equivalent of the native setting.

## ◆ toCommonMode()

stdAc::opmode_t IRHitachiAc1::toCommonMode | ( | const uint8_t | mode | ) |

static

Convert a native mode into its stdAc equivalent.

Parameters

  [in] | mode | The native setting to be converted.

Returns
  The stdAc equivalent of the native setting.

## ◆ toString()

String IRHitachiAc1::toString | ( | void |  | ) | const

Convert the current internal state into a human readable string.

Returns
  A human readable string.

## ◆ validChecksum()

bool IRHitachiAc1::validChecksum | ( | const uint8_t | state[],
|  | const uint16_t | length = `kHitachiAc1StateLength`
| ) |  |

static

Verify the checksum is valid for a given state.

Parameters

  [in] | state | The array to verify the checksum of.
  [in] | length | The length of the state array.

Returns
  true, if the state has a valid checksum. Otherwise, false.

## Member Data Documentation

## ◆ _

Hitachi1Protocol IRHitachiAc1::_

private

## ◆ _irsend

IRsend IRHitachiAc1::_irsend

private

Instance of the IR send class.

The documentation for this class was generated from the following files:

- src/ir_Hitachi.h
- src/ir_Hitachi.cpp